//+------------------------------------------------------------------+
//|                                       Fractal dimesion index.mq4 |
//|                                                           mladen |
//|                                                                  |
//| As from the article by Calos Sevcik                              |
//| http://www.complexity.org.au/ci/vol05/sevcik/sevcik.html         |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Red

//
//
//
//
//

extern int FDILength=30;
extern int FDIPrice =PRICE_CLOSE;

//
//
//
//
//

double FDIBuffer[];
double PriceBuffer[];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(2);
   SetIndexBuffer(0,FDIBuffer);   SetIndexDrawBegin(0,FDILength);
   SetIndexBuffer(1,PriceBuffer);
   return(0);
}
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double dx2 = MathPow(1.0/(FDILength-1.0),2);
   double dl2 = MathLog(2.0*(FDILength-1.0));
   int    counted_bars=IndicatorCounted();
   int    i,limit;
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //
            
   for (i=limit;i>=0;i--)
   {
      PriceBuffer[i] = iMA(NULL,0,1,0,MODE_SMA,FDIPrice,i);
      
      //
      //
      //
      //
      //
     
      double priceMax = maxValue(PriceBuffer,FDILength,i);
      double priceMin = minValue(PriceBuffer,FDILength,i);
      double length   = 0.00;
      double di       = priceMax-priceMin;

            if (di==0) FDIBuffer[i] = 0.00;
            else         
            {
               for (int k = 0; k<FDILength; k++)
               {
                  double dp;
                  double dy = (PriceBuffer[i+k]-priceMin)/di;
                           if (k>0) length += MathSqrt(MathPow(dy-dp,2)+dx2);
                  dp = dy;
               }
               FDIBuffer[i] = 1.0 + MathLog(length)/dl2;
            }
   }         
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double minValue(double& array[],int period,int shift)
{
   double minValue = array[shift];
            for (int i=1; i<period; i++) minValue = MathMin(minValue,array[shift+i]);
   return(minValue);
}
double maxValue(double& array[],int period,int shift)
{
   double maxValue = array[shift];
            for (int i=1; i<period; i++) maxValue = MathMax(maxValue,array[shift+i]);
   return(maxValue);
}